# Read "ReadMe.txt/.html" for ...

push @plugins, 'httpd';
push @plugins, 'h8080';

sub h8080 {
$httpd_host = shift;
&httpd($httpd_host, 8080);
}

sub httpd {
$httpd_host = shift;
$httpd_port = shift;
$x=0; $server="";
$httpd_port = 80 if ($httpd_port == "");

$httpd = IO::Socket::INET->new(PeerAddr => $httpd_host,
			       PeerPort => $httpd_port,
			       Proto    => "tcp",
			       Timeout  => $timeout) || $x++;
if($x == 0) {
    print $httpd "HEAD / HTTP/1.0\r\n\r\n";

while(<$httpd>) {
    if (/^Server: (.*)/) {
	$server=$1;
    }
}

close $httpd;
chomp $server;
if(!$server) { return; }
$_=$server;
    if(/ncsa/i && /1.3/) {
	print "[$httpd_host] - [NCSA 1.3]\n";
	print LOG "[$httpd_host] - [NCSA 1.3]\n";
	return;
    }
    if(/ncsa/i && /1.4.1/) {
	print "[$httpd_host] - [NCSA 1.4.1]\n";
	print LOG "[$httpd_host] - [NCSA 1.4.1]\n";
	return;
    }
    if(/ncsa/i && /1.4.2/) {
	print "[$httpd_host] - [NCSA 1.4.2]\n";
	print LOG "[$httpd_host] - [NCSA 1.4.2]\n";
	return;
    }
    if(/ncsa/i && /1.5.1/) {
	print "[$httpd_host] - [NCSA 1.5.1]\n";
	print LOG "[$httpd_host] - [NCSA 1.5.1]\n";
	return;
    }
    if(/ncsa/i && /1.5.2/) {
	print "[$httpd_host] - [NCSA 1.5.2]\n";
	print LOG "[$httpd_host] - [NCSA 1.5.2]\n";
	return;
    }
    if(/ncsa/i && /1.4/) {
	print "[$httpd_host] - [NCSA 1.4]\n";
	print LOG "[$httpd_host] - [NCSA 1.4]\n";
	return;
    }
    if(/ncsa/i && /1.5/) {
	print "[$httpd_host] - [NCSA 1.5]\n";
	print LOG "[$httpd_host] - [NCSA 1.5]\n";
	return;
    }
    if(/dwhttpd/i && /3.1a4/) {
	print "[$httpd_host] - [dwhttpd 3.1a4]\n";
	print LOG "[$httpd_host] - [dwhttpd 3.1a4]\n";
	return;
    }
    if(/ews/i && /1.1/) {
	print "[$httpd_host] - [EWS 1.1]\n";
	print LOG "[$httpd_host] - [EWS 1.1]\n";
	return;
    }
    if(/microsoft-iis/i && /([1-4]).0/) {
	print "[$httpd_host] - [Microsoft-IIS $1.0]\n";
	print LOG "[$httpd_host] - [Microsoft-IIS $1.0]\n";
	return;
    }
    if(/vqserver/i) {
	print "[$httpd_host] - [VqServer]\n";
	print LOG "[$httpd_host] - [VqServer]\n";
	return;
    }
    if(/alibaba/i && /([2-3]).0/) {
	print "[$httpd_host] - [Alibaba $1.0]\n";
	print LOG "[$httpd_host] - [Alibaba $1.0]\n";
	return;
    }
    if(/teamtrack/i && /3.00/) {
	print "[$httpd_host] - [TeamTrack 3.00]\n";
	print LOG "[$httpd_host] - [TeamTrack 3.00]\n";
	return;
    }
    # Check out http://www.legion2000.cc/ (Under "INFO") for
    # more information ...
    if(/jweb/i && /1.([0-5])/) {
	print "[$httpd_host] - [JWeb 1.$1]\n";
	print LOG "[$httpd_host] - [JWeb 1.$1]\n";
	return;
    }
    if(/falcon/i && /1.0.0.1006/) {
	print "[$httpd_host] - [Falcon Web Server 1.0.0.1006]\n";
	print LOG "[$httpd_host] - [Falcon Web Server 1.0.0.1006]\n";
	return;
    }
    if(/url live/i && /1.0/) {
	print "[$httpd_host] - [URL Live! 1.0]\n";
	print LOG "[$httpd_host] - [URL Live! 1.0]\n";
	return;
    }
    if(/thttpd/i && /2.04/) {
	print "[$httpd_host] - [THTTPD 2.04]\n";
	print LOG "[$httpd_host] - [THTTPD 2.04]\n";
	return;
    }
    if(/eserv/i && /2.50/) {
	print "[$httpd_host] - [EServ 2.50]\n";
	print LOG "[$httpd_host] - [EServ 2.50]\n";
	return;
    }
 }
}
print;